require 'thor'
require 'highline'

module Rsb
  module Gol
    class Cli < Thor
      class_option :iterations, type: :numeric, default: 1_000_000
      class_option :alive_char, type: :string, default: '●'
      class_option :death_char, type: :string, default: ' '
      class_option :columns,    type: :numeric
      class_option :rows,       type: :numeric

      desc 'start', 'start the game of life'
      def start
        columns, rows = HighLine::SystemExtensions.terminal_size
        rows      -= 10
        columns   -= 10
        iterations = options.iterations
        alive      = options.alive_char
        dead       = options.death_char

        columns = options.columns if options.columns?
        rows    = options.rows    if options.rows?

        # ✺ ☻ ⬣ ● ⨀
        game = Rsb::Gol::Game.new(cols: columns, rows: rows)
        game.start(iterations, alive, dead)
      end
    end
  end
end
